{VERSION 1 0 "X11/Motif" "1.0"}{GLOBALS 1 1}{FONT 0 "fixed" "fixe
d" "Courier" 4 12 192 "Courier-Bold" 9}{FONT 1 "-adobe-times-medi
um-r-normal--20-*-*" "times" "Times-Roman" 4 12 64 "Times-Roman" 
9}{FONT 2 "-adobe-courier-medium-r-normal--20-*-*" "courier" "Cou
rier" 4 12 192 "Courier" 9}{SCP_R 1 0 94{COM_R 2 0{TEXT 1 54 "TP \+
Maple : Etude des puissances d'une matrice carree.\015"}}{INP_R 3
 0 "> "{TEXT 0 13 "with(linalg):"}}{OUT_R 4 0 3{TEXT 2 71 "Warnin
g: new definition for   norm\012Warning: new definition for   tra
ce\012"}}{COM_R 5 0{TEXT 1 91 "\015mathasard(n,a,b) tire une matr
ice n*n au hasard avec des coefficients compris entre a et b"}}
{INP_R 6 0 "> "{TEXT 0 197 "mathasard := proc(n:integer,a:numeric
,b:numeric)\012local M,i,j;\012  M := matrix(n,n);\012  for i fro
m 1 to n do for j from 1 to n do \012    M[i,j] := a + (b-a)*rand
()*Float(1,-12);\012  od od;\012  evalm(M);\012end:"}}{COM_R 7 0
{TEXT 1 58 "\015stochasard(n) tire une matrice n*n stochastique a
u hasard"}}{INP_R 8 0 "> "{TEXT 0 225 "stochasard := proc(n:integ
er)\012local M,i,j,s;\012  M := randmatrix(n,n,entries=rand);\012
  for i from 1 to n do\012    j := 'j';\012    s := sum(M[i,j],j=
1..n);\012    for j from 1 to n do M[i,j] := evalf(M[i,j]/s) od;\
012  od;\012  evalm(M);\012end:"}}{COM_R 9 0{TEXT 1 56 "\015ps(A,
B) calcule le produit scalaire des matrices A et B"}}{INP_R 10 0 
"> "{TEXT 0 220 "ps := proc(A:matrix,B:matrix)\012local i,j;\012 \+
 if (rowdim(A) <> rowdim(B)) or (coldim(A) <> coldim(B))\012  the
n ERROR(`matrices de dimensions differentes`)\012  else sum(sum(A
[i,j]*B[i,j],i=1..rowdim(A)),j=1..coldim(A))\012  fi\012end:"}}
{COM_R 11 0{TEXT 1 37 "\015mround(x,n) arrondit x a n decimales"}
}{INP_R 12 0 "> "{TEXT 0 170 "mround := proc(x,n:integer)\012   i
f type(x,numeric) then round(Float(1,n)*x)*Float(1,-n)\012 elif t
ype(x,name) then x\012 elif evalb(x=I)   then x\012 else map(mrou
nd,x,n) \012 fi\012end:"}}{COM_R 13 0{TEXT 1 44 "\015mprint(x,n) \+
imprime x arrondi a n decimales"}}{INP_R 14 0 "> "{TEXT 0 44 "mpr
int := (x,n) -> print(mround(eval(x),n)):"}}{COM_R 15 0{TEXT 1 65
 "\015-----------------------------------------------------------
---\015\015"}}{COM_R 16 0{TEXT 1 81 "relation(A,B,C) cherche si C
 est approximativement combinaison lineaire de A et B"}}{INP_R 17
 0 "> "{TEXT 0 276 "rel := proc(A:matrix,B:matrix,C:matrix)\012lo
cal aa,ab,ac,bb,bc,s2,x,y;\012  aa := ps(A,A);\012  ab := ps(A,B)
; ac := ps(A,C);\012  bb := ps(B,B); bc := ps(B,C);\012  s2 := 1 \+
- ab^2/aa/bb;\012  if s2 < 0.001 then [bc/bb,0]\012  else subs(so
lve(\{x*bb+y*ab=bc, x*ab+y*aa=ac\},\{x,y\}),[x,y])\012  fi\012end
: "}}{COM_R 18 0{TEXT 1 152 "\015job(M,p) calcule les puissances \+
de M et cherche une relation de recurrence approximative d'ordre \+
2 entre ces puissances. Arrete au bout de p iterations"}}{INP_R 
19 0 "> "{TEXT 0 291 "job := proc(M:matrix,p:integer)\012global A
;\012local B,C,i,x,r,v;\012  A := evalm(M):\012  for i from 1 to \+
p do\012    A := evalm(A &* A); A := evalm(1/norm(A)*A);\012    B
 := evalm(A &* M);\012    C := evalm(B &* M);\012    r := rel(A,B
,C); mprint(r,5);\012  od;\012  v := [solve(x^2=r[1]*x+r[2],x)]:\
012  mprint(v,5)\012end:"}}{COM_R 20 0{TEXT 1 58 "\015proj1(A) ca
lcule la matrice de projection colineaire a A."}}{INP_R 21 0 "> "
{TEXT 0 83 "proj1 := proc(A:matrix)\012local c;\012  c := ps(A,A)
/ps(evalm(A^2),A);\012  evalm(c*A)\012end:"}}{COM_R 22 0{TEXT 1 
257 "     \015proj2(M,A) calcule la matrice de projection sur le \+
sous-espace approximativement defini par A, puissance de M. La ma
trice de projection cherchee est une combinaison lineaire de A et
 MA, on determine les coefficients par la methode des moindres ca
rres."}}{INP_R 23 0 "> "{TEXT 0 258 "proj2 := proc(M:matrix,A:mat
rix)\012local B,P,Z,s,x,y;\012  B := evalm(M &* A);\012  P := eva
lm(x*A + y*B);  \012  Z := evalm(P &* P - P);\012  s := solve(\{p
s(A,Z) = 0, ps(B,Z) = 0\},\{x,y\});\012  s := subs(\{x=0,y=0\}=NU
LL,\{y=0,x=0\}=NULL,[s]);\012  assign(s[1]);\012  map(eval,P)\012
end: "}}{COM_R 24 0{TEXT 1 7 "\015Essais"}}{INP_R 25 0 "> "{TEXT 
0 91 "M := mathasard(6,-2,2):mprint(M,3);\012l := [eigenvals(M)]:
 mprint(l,5); mprint(map(abs,l),5);"}}{OUT_R 26 0 25{DAG (3n4\`MA
TRIX`,2[2,7[2,7e3j2x0911i2x0003e3i2x1649pCe3i2x0923pCe3j2x1902pCe
3j2x0832pCe3i2x1560pC[2,7e3j2x1037pCe3j2x0936pCe3j2x0063pCe3j2x04
07pCe3j2x1317pCe3j2x1679pC[2,7e3j2x1147pCe3i2x0587pCe3i2x0462pCe3
i2x1710pCe3i2x1312pCe3j2x0323pC[2,7e3i2x1888pCe3j2x1380pCe3j2x005
7pCe3i2x1941pCe3i2x1177pCe3j2x1409pC[2,7e3j2x0510pCe3i2x0869pCe3i
2x1850pCe3i2x1429pCe3i2x1005pCe3i2x0725pC[2,7e3j2x0269pCe3i2x0706
pCe3i2x0786pCe3j2x0024pCe3i2x0610pCe3i2x1070pC}}{OUT_R 27 0 25
{DAG [2,7e3i3x00318903i2x0005+5e3i3x00011305p6j2x0001n3\`I`e3j3x0
0245805p6+5p9pEp10e3i3x00245805p6e3i3x00070350p6e3j3x00112045p6e3
j3x00036657p6}}{OUT_R 28 0 25{DAG [2,7e3j3x00318903i2x0005e3j3x00
246065p6p8e3j3x00070350p6e3j3x00112045p6e3j3x00036657p6}}{INP_R 
29 0 "> "{TEXT 0 111 "i := 'i': A := evalm(M):\012for i from 1 to
 10 do\012  A := evalm(A &* A): A := evalm(1/norm(A)*A):\012  mpr
int(A,3)\012od:"}}{OUT_R 30 0 29{DAG (3n4\`MATRIX`,2[2,7[2,7e3i2x
0231i2x0003e3j2x0021pCe3i2x0030pCe3i2x0095pCe3i2x0097pCe3i2x0031p
C[2,7e3j2x0098pCe3i2x0110pCe3i2x0195pCe3i2x0016pCe3i2x0034pCe3i2x
0092pC[2,7e3j2x0106pCe3i2x0151pCe3j2x0050pCe3j2x0331pCe3j2x0164pC
e3i2x0197pC[2,7e3j2x0134pCe3j2x0072pCe3j2x0115pCp24e3j2x0116pCe3j
2x0079pC[2,7e3i2x0024pCe3i2x0048pCe3j2x0112pCe3j2x0333pCe3j2x0202
pCe3i2x0140pC[2,7e3i2x0085pCe3j2x0028pCe3j2x0085pCe3j2x0099pCe3j2
x0065pCe3i2x0010pC}}{OUT_R 31 0 29{DAG (3n4\`MATRIX`,2[2,7[2,7e3j
2x0120i2x0003e3i2x0015pCe3i2x0063pCe3i2x0090pCe3i2x0043pCe3j2x004
8pC[2,7e3i2x0130pCe3j2x0113pCe3i2x0013pCe3i2x0256pCe3i2x0142pCe3j
2x0136pC[2,7e3j2x0064pCe3j2x0059pCe3j2x0186pCe3j2x0208pCe3j2x0168
pCe3j2x0016pC[2,7e3i2x0022pCe3i2x0051pCe3j2x0051pCe3j2x0219pCe3j2
x0118pCe3i2x0117pC[2,7e3j2x0175pCe3i2x0005pCe3j2x0176pCe3j2x0344p
Ce3j2x0252pCe3i2x0048pC[2,7p9e3i2x0038pCe3j2x0052pCe3j2x0180pCe3j
2x0123pCe3i2x0049pC}}{OUT_R 32 0 29{DAG (3n4\`MATRIX`,2[2,7[2,7e3
j2x0025i2x0003e3i2x0009pCe3i2x0059pCe3i2x0094pCe3i2x0060pCe3j2x00
26pC[2,7e3i2x0070pCe3j2x0046pCe3i2x0055pCe3i2x0204pCe3i2x0126pCe3
j2x0079pC[2,7p38e3j2x0009pCe3j2x0144pCe3j2x0253pCe3j2x0181pCe3i2x
0039pC[2,7e3j2x0019pCe3i2x0020pCe3j2x0076pCe3j2x0190pCe3j2x0119pC
e3i2x0066pC[2,7e3j2x0131pCp59e3j2x0166pCe3j2x0357pCe3j2x0246pCe3i
2x0080pC[2,7e3j2x0070pCe3i2x0023pCe3j2x0063pCe3j2x0169pCe3j2x0113
pCe3i2x0047pC}}{OUT_R 33 0 29{DAG (3n4\`MATRIX`,2[2,7[2,7e3i2x002
3i2x0003e3j2x0003pCe3i2x0052pCe3i2x0104pCe3i2x0070pCe3j2x0025pC[2
,7e3i2x0050pCe3j2x0015pCe3i2x0079pCe3i2x0181pCe3i2x0120pCe3j2x005
0pC[2,7e3j2x0080pCe3i2x0014pCe3j2x0130pCe3j2x0277pCe3j2x0188pCe3i
2x0067pC[2,7e3j2x0046pCe3i2x0011pCe3j2x0085pCe3j2x0184pCe3j2x0123
pCe3i2x0048pC[2,7e3j2x0106pCp9e3j2x0167pCe3j2x0366pCe3j2x0247pCe3
i2x0092pC[2,7e3j2x0048pCe3i2x0012pCe3j2x0072pCe3j2x0163pCe3j2x010
9pCe3i2x0042pC}}{OUT_R 34 0 29{DAG (3n4\`MATRIX`,2[2,7[2,7e3i2x00
30i2x0003e3j2x0006pCe3i2x0050pCe3i2x0108pCe3i2x0073pCe3j2x0027pC[
2,7p12e3j2x0011pCe3i2x0082pCe3i2x0179pCe3i2x0120pCe3j2x0045pC[2,7
e3j2x0078pCe3i2x0016pCe3j2x0129pCe3j2x0281pCe3j2x0189pCe3i2x0071p
C[2,7e3j2x0052pCe3i2x0011pCe3j2x0085pCe3j2x0185pCe3j2x0125pCe3i2x
0047pC[2,7e3j2x0103pCe3i2x0022pCe3j2x0169pCe3j2x0367pCe3j2x0247pC
e3i2x0093pC[2,7p35e3i2x0010pCe3j2x0074pCe3j2x0162pCe3j2x0109pCe3i
2x0041pC}}{OUT_R 35 0 29{DAG (3n4\`MATRIX`,2[2,7[2,7e3i2x0030i2x0
003e3j2x0006pCe3i2x0049pCe3i2x0108pCe3i2x0073pCe3j2x0027pC[2,7e3i
2x0050pCe3j2x0011pCe3i2x0082pCe3i2x0179pCe3i2x0120pCe3j2x0045pC[2
,7e3j2x0078pCe3i2x0016pCe3j2x0129pCe3j2x0281pCe3j2x0189pCe3i2x007
1pC[2,7e3j2x0052pCe3i2x0011pCe3j2x0085pCe3j2x0186pCe3j2x0125pCe3i
2x0047pC[2,7e3j2x0103pCe3i2x0022pCe3j2x0169pCe3j2x0367pCe3j2x0247
pCe3i2x0093pC[2,7p38e3i2x0010pCe3j2x0074pCe3j2x0162pCe3j2x0109pCe
3i2x0041pC}}{OUT_R 36 0 29{DAG (3n4\`MATRIX`,2[2,7[2,7e3i2x0030i2
x0003e3j2x0006pCe3i2x0049pCe3i2x0108pCe3i2x0073pCe3j2x0027pC[2,7e
3i2x0050pCe3j2x0011pCe3i2x0082pCe3i2x0179pCe3i2x0120pCe3j2x0045pC
[2,7e3j2x0078pCe3i2x0016pCe3j2x0129pCe3j2x0281pCe3j2x0189pCe3i2x0
071pC[2,7e3j2x0052pCe3i2x0011pCe3j2x0085pCe3j2x0186pCe3j2x0125pCe
3i2x0047pC[2,7e3j2x0103pCe3i2x0022pCe3j2x0169pCe3j2x0367pCe3j2x02
47pCe3i2x0093pC[2,7p38e3i2x0010pCe3j2x0074pCe3j2x0162pCe3j2x0109p
Ce3i2x0041pC}}{OUT_R 37 0 29{DAG (3n4\`MATRIX`,2[2,7[2,7e3i2x0030
i2x0003e3j2x0006pCe3i2x0049pCe3i2x0108pCe3i2x0073pCe3j2x0027pC[2,
7e3i2x0050pCe3j2x0011pCe3i2x0082pCe3i2x0179pCe3i2x0120pCe3j2x0045
pC[2,7e3j2x0078pCe3i2x0016pCe3j2x0129pCe3j2x0281pCe3j2x0189pCe3i2
x0071pC[2,7e3j2x0052pCe3i2x0011pCe3j2x0085pCe3j2x0186pCe3j2x0125p
Ce3i2x0047pC[2,7e3j2x0103pCe3i2x0022pCe3j2x0169pCe3j2x0367pCe3j2x
0247pCe3i2x0093pC[2,7p38e3i2x0010pCe3j2x0074pCe3j2x0162pCe3j2x010
9pCe3i2x0041pC}}{OUT_R 38 0 29{DAG (3n4\`MATRIX`,2[2,7[2,7e3i2x00
30i2x0003e3j2x0006pCe3i2x0049pCe3i2x0108pCe3i2x0073pCe3j2x0027pC[
2,7e3i2x0050pCe3j2x0011pCe3i2x0082pCe3i2x0179pCe3i2x0120pCe3j2x00
45pC[2,7e3j2x0078pCe3i2x0016pCe3j2x0129pCe3j2x0281pCe3j2x0189pCe3
i2x0071pC[2,7e3j2x0052pCe3i2x0011pCe3j2x0085pCe3j2x0186pCe3j2x012
5pCe3i2x0047pC[2,7e3j2x0103pCe3i2x0022pCe3j2x0169pCe3j2x0367pCe3j
2x0247pCe3i2x0093pC[2,7p38e3i2x0010pCe3j2x0074pCe3j2x0162pCe3j2x0
109pCe3i2x0041pC}}{OUT_R 39 0 29{DAG (3n4\`MATRIX`,2[2,7[2,7e3i2x
0030i2x0003e3j2x0006pCe3i2x0049pCe3i2x0108pCe3i2x0073pCe3j2x0027p
C[2,7e3i2x0050pCe3j2x0011pCe3i2x0082pCe3i2x0179pCe3i2x0120pCe3j2x
0045pC[2,7e3j2x0078pCe3i2x0016pCe3j2x0129pCe3j2x0281pCe3j2x0189pC
e3i2x0071pC[2,7e3j2x0052pCe3i2x0011pCe3j2x0085pCe3j2x0186pCe3j2x0
125pCe3i2x0047pC[2,7e3j2x0103pCe3i2x0022pCe3j2x0169pCe3j2x0367pCe
3j2x0247pCe3i2x0093pC[2,7p38e3i2x0010pCe3j2x0074pCe3j2x0162pCe3j2
x0109pCe3i2x0041pC}}{INP_R 40 0 "> "{TEXT 0 10 "job(M,10);"}}
{OUT_R 41 0 40{DAG [2,3e3i3x00258806i2x0005e3i3x00141887p6}}
{OUT_R 42 0 40{DAG [2,3e3i3x00286028i2x0005e3i2x6388p6}}{OUT_R 43
 0 40{DAG [2,3e3i3x00308454i2x0005e3j3x00020889p6}}{OUT_R 44 0 40
{DAG [2,3e3i3x00318819i2x0005j2x0000}}{OUT_R 45 0 40{DAG [2,3e3i3
x00318897i2x0005j2x0000}}{OUT_R 46 0 40{DAG [2,3e3i3x00318903i2x0
005j2x0000}}{OUT_R 47 0 40{DAG [2,3e3i3x00318903i2x0005j2x0000}}
{OUT_R 48 0 40{DAG [2,3e3i3x00318903i2x0005j2x0000}}{OUT_R 49 0 
40{DAG [2,3e3i3x00318903i2x0005j2x0000}}{OUT_R 50 0 40{DAG [2,3e3
i3x00318903i2x0005j2x0000}}{OUT_R 51 0 40{DAG [2,3j2x0000e3i3x003
18903i2x0005}}{INP_R 52 0 "> "{TEXT 0 43 "M1 := evalm(M - M &* pr
oj1(A)): job(M1,10):"}}{OUT_R 53 0 52{DAG [2,3e3i3x00020245i2x000
5e3i3x00573609p6}}{OUT_R 54 0 52{DAG [2,3e3i3x00022397i2x0005e3i3
x00606283p6}}{OUT_R 55 0 52{DAG [2,3e3i3x00022601i2x0005e3i3x0060
5476p6}}{OUT_R 56 0 52{DAG [2,3e3i3x00022610i2x0005e3i3x00605478p
6}}{OUT_R 57 0 52{DAG [2,3e3i3x00022610i2x0005e3i3x00605478p6}}
{OUT_R 58 0 52{DAG [2,3e3i3x00022610i2x0005e3i3x00605478p6}}
{OUT_R 59 0 52{DAG [2,3e3i3x00022610i2x0005e3i3x00605478p6}}
{OUT_R 60 0 52{DAG [2,3e3i3x00022610i2x0005e3i3x00605478p6}}
{OUT_R 61 0 52{DAG [2,3e3i3x00022610i2x0005e3i3x00605478p6}}
{OUT_R 62 0 52{DAG [2,3e3i3x00022610i2x0005e3i3x00605478p6}}
{OUT_R 63 0 52{DAG [2,3+5e3i3x00011305i2x0005j2x0001n3\`I`e3j3x00
245805p7+5p3p9pBe3i3x00245805p7}}{INP_R 64 0 "> "{TEXT 0 48 "M2 :
= evalm(M1 - M1 &* proj2(M1,A)): job(M2,10):"}}{OUT_R 65 0 64{DAG
 [2,3e3j3x00041932i2x0005e3j3x00078367p6}}{OUT_R 66 0 64{DAG [2,3
e3j3x00041670i2x0005e3j3x00078903p6}}{OUT_R 67 0 64{DAG [2,3e3j3x
00041688i2x0005e3j3x00078832p6}}{OUT_R 68 0 64{DAG [2,3e3j3x00112
025i2x0005j2x0000}}{OUT_R 69 0 64{DAG [2,3e3j3x00112045i2x0005j2x
0000}}{OUT_R 70 0 64{DAG [2,3e3j3x00112045i2x0005j2x0000}}{OUT_R 
71 0 64{DAG [2,3e3j3x00112045i2x0005j2x0000}}{OUT_R 72 0 64{DAG [
2,3e3j3x00112045i2x0005j2x0000}}{OUT_R 73 0 64{DAG [2,3e3j3x00112
045i2x0005j2x0000}}{OUT_R 74 0 64{DAG [2,3e3j3x00112045i2x0005j2x
0000}}{OUT_R 75 0 64{DAG [2,3j2x0000e3j3x00112045i2x0005}}{INP_R 
76 0 "> "{TEXT 0 45 "M3 := evalm(M2 - M2 &* proj1(A)): job(M3,10)
:"}}{OUT_R 77 0 76{DAG [2,3e3i3x00033693i2x0005e3j3x00025788p6}}
{OUT_R 78 0 76{DAG [2,3e3i3x00033693i2x0005e3j3x00025788p6}}
{OUT_R 79 0 76{DAG [2,3e3i3x00070342i2x0005j2x0000}}{OUT_R 80 0 
76{DAG [2,3e3i3x00070350i2x0005j2x0000}}{OUT_R 81 0 76{DAG [2,3e3
i3x00070350i2x0005j2x0000}}{OUT_R 82 0 76{DAG [2,3e3i3x00070350i2
x0005j2x0000}}{OUT_R 83 0 76{DAG [2,3e3i3x00070350i2x0005j2x0000}
}{OUT_R 84 0 76{DAG [2,3e3i3x00070350i2x0005j2x0000}}{OUT_R 85 0 
76{DAG [2,3e3i3x00070350i2x0005j2x0000}}{OUT_R 86 0 76{DAG [2,3e3
i3x00070350i2x0005j2x0000}}{OUT_R 87 0 76{DAG [2,3j2x0000e3i3x000
70350i2x0005}}{INP_R 88 0 "> "{TEXT 0 44 "M4 := evalm(M3 - M3 &* \+
proj1(A)): job(M4,5):"}}{OUT_R 89 0 88{DAG [2,3e3j3x00036657i2x00
05j2x0000}}{OUT_R 90 0 88{DAG [2,3e3j3x00036657i2x0005j2x0000}}
{OUT_R 91 0 88{DAG [2,3e3j3x00036657i2x0005j2x0000}}{OUT_R 92 0 
88{DAG [2,3e3j3x00036657i2x0005j2x0000}}{OUT_R 93 0 88{DAG [2,3e3
j3x00036657i2x0005j2x0000}}{OUT_R 94 0 88{DAG [2,3j2x0000e3j3x000
36657i2x0005}}{INP_R 95 0 "> "{TEXT 0 0 ""}}}{END}
